/*
 * NBCT
 * Copyright (c) 2007-2010, Yoshitaka Kameya
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms,  with or without
 * modification,  are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions  in  binary  form  must  reproduce  the  above
 *    copyright notice,  this list of conditions  and  the following
 *    disclaimer  in  the  documentation  and/or   other   materials
 *    provided with the distribution.
 *  * Neither  the  name  of  Tokyo Institute of Technology  nor the
 *    names of its contributors may be used to  endorse  or  promote
 *    products derived from  this  software  without  specific prior
 *    written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS"  AND  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO,  THE IMPLIED WARRANTIES OF MERCHANTABILITY  AND FITNESS
 * FOR  A  PARTICULAR  PURPOSE  ARE  DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL,    SPECIAL,   EXEMPLARY,   OR   CONSEQUENTIAL   DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO,  PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS;  OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT  LIABILITY,  OR  TORT  (INCLUDING  NEGLIGENCE  OR OTHERWISE)
 * ARISING  IN  ANY  WAY  OUT  OF  THE  USE  OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef VNBC_EXT_H
#define VNBC_EXT_H

extern OPTION vnbc_opts[];

extern int mode_predict;
extern char fname_predict[MAX_FILENAME_AUX];

extern FLOAT_T *hparam_c;
extern FLOAT_T *hparam_c_upd;
extern FLOAT_T *hparam_c_opt;
extern FLOAT_T *hparam_c_best;
extern FLOAT_T *hparam_c_sm;
extern FLOAT_T *hparam_c_upd_opt;
extern FLOAT_T *hparam_c_upd_best;
extern FLOAT_T *hparam_c_upd_sm;
extern FLOAT_T ***hparam_w;
extern FLOAT_T ***hparam_w_opt;
extern FLOAT_T ***hparam_w_best;
extern FLOAT_T ***hparam_w_sm;
extern FLOAT_T ***hparam_w_upd;
extern FLOAT_T ***hparam_w_upd_opt;
extern FLOAT_T ***hparam_w_upd_best;
extern FLOAT_T ***hparam_w_upd_sm;
extern FLOAT_T *pi_c;
extern FLOAT_T ***pi_w;
extern FLOAT_T **pi_g;
extern VECTOR **hparam_u_best;
extern VECTOR **hparam_u_sm;
extern VECTOR **hparam_u_upd;
extern VECTOR **hparam_u_upd_best;
extern VECTOR **hparam_u_upd_opt;
extern VECTOR **hparam_u_upd_sm;
extern MATRIX **hparam_s_best;
extern MATRIX **hparam_s_sm;
extern MATRIX **hparam_s_upd;
extern MATRIX **hparam_s_upd_best;
extern MATRIX **hparam_s_upd_opt;
extern MATRIX **hparam_s_upd_sm;
extern MATRIX **hparam_p_best;
extern MATRIX **hparam_p_sm;
extern MATRIX **hparam_p_upd;
extern MATRIX **hparam_p_upd_best;
extern MATRIX **hparam_p_upd_opt;
extern MATRIX **hparam_p_upd_sm;
extern FLOAT_T **hparam_sdet_best;
extern FLOAT_T **hparam_sdet_sm;
extern FLOAT_T **hparam_sdet_upd;
extern FLOAT_T **hparam_sdet_upd_best;
extern FLOAT_T **hparam_sdet_upd_opt;
extern FLOAT_T **hparam_sdet_upd_sm;
extern FLOAT_T *expect_c_best;
extern FLOAT_T *expect_c_opt;
extern FLOAT_T *expect_c_sm;
extern FLOAT_T prob_cond_mid;

extern int free_energy_size;
extern FLOAT_T *free_energy;
extern FLOAT_T *free_energy_best;
extern FLOAT_T final_free_energy;
extern FLOAT_T final_free_energy_best;
extern FLOAT_T **log_final_free_energy;
extern int *free_energy_sm_size;
extern FLOAT_T **free_energy_sm;

#endif
